/*
 * Copyright (C) 2017 Guido Berhoerster <guido+pwm@berhoerster.name>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef	COMPAT_H
#define	COMPAT_H

/* for glibc asprintf, getline */
#define	_GNU_SOURCE

#ifndef	HAVE_ASPRINTF
#include "compat/asprintf.h"
#endif /* !HAVE_ASPRINTF */

#ifndef	HAVE_CLOSEFROM
#include "compat/closefrom.h"
#endif /* !HAVE_CLOSEFROM */

#ifndef	HAVE_ERR_H
#include "compat/err.h"
#endif /* !HAVE_ERR_H */

#ifndef	HAVE_GETENTROPY
#include "compat/getentropy.h"
#endif /* !HAVE_GETENTROPY */

#ifndef	HAVE_SYS_QUEUE_H
#include "compat/queue.h"
#endif /* !HAVE_SYS_QUEUE_H */

#ifndef	HAVE_SETPROGNAME
#include "compat/setprogname.h"
#endif /* !HAVE_SETPROGNAME */

#ifndef	HAVE_SYS_TREE_H
#include "compat/tree.h"
#endif /* !HAVE_SYS_TREE_H */

#endif /* COMPAT_H */
