/*
 * Copyright (C) 2017 Guido Berhoerster <guido+pwm@berhoerster.name>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef	PWM_H
#define	PWM_H

#include <libtecla.h>
#include <pws.h>

#ifndef	PWM_LINE_MAX
#define	PWM_LINE_MAX	16384
#endif /* !PWM_LINE_MAX */

#ifndef	PWM_HISTORY_ENTRIES_MAX
#define	PWM_HISTORY_ENTRIES_MAX	1024
#endif /* !PWM_HISTORY_MAX */

#ifndef	PWM_HISTORY_LINES_MAX
#define	PWM_HISTORY_LINES_MAX	256
#endif /* !PWM_HISTORY_LINES_MAX */

#ifndef	PWM_HISTORY_MAX
#define	PWM_HISTORY_MAX	(PWM_HISTORY_LINES_MAX * PWM_LINE_MAX)
#endif /* !PWM_HISTORY_MAX */

struct pwm_ctx {
	const char	*prev_cmd;
	char		*errmsg;
	char		*dirname;
	char		*filename;
	struct pws3_file *file;
	struct record_id_tree *record_id_tree;
	int		unsaved_changes;
	unsigned int	next_id;
	char		password[PWS3_MAX_PASSWORD_LEN + 1];
};

void	pwm_err(struct pwm_ctx *, char *, ...);
void	pwm_block_signals(void);
void	pwm_unblock_signals(void);
int	pwm_read_password(struct pwm_ctx *, int);

#endif /* PWM_H */
